SET DEFINE OFF;

--
-- 
-- ____________________________________________________________________________________________
--  /!\ ATTENTION /!\  fichier encodé en UTF-8   (  il peut  contenir des é è ç à î ê ô ... )
-- ____________________________________________________________________________________________
--
--

--
-- 
-- Fichier: n°4
-- Type: DDL
-- Schéma:  RECHERCHE
-- Numéro de version :  1.0.0.0
-- Date de publication :  07/12/2010
-- Auteurs : Julien Lafourcade, Bruno Garnier
-- Licence : CeCILL version 2
--
--


/*
	Création des tables pour la partie gestion des structures  de recherche
*/


whenever sqlerror exit sql.sqlcode ;


-- UNITE DE RECHERCHE

-- TABLE DE REPARTITION DES DS PAR UNITE
CREATE TABLE RECHERCHE.REPART_UNIT_RECH_DOM_SC
(
	RURDS_ID NUMBER NOT NULL,
	C_STRUCTURE VARCHAR2(10) NOT NULL,
	DOMAINE_SCIENT_ORDRE NUMBER NOT NULL,
	PRINCIPAL NUMBER(1),
	PERS_ID_CREATION NUMBER NOT NULL,
	PERS_ID_MODIFICATION NUMBER NOT NULL,
	D_CREATION DATE NOT NULL,
	D_MODIFICATION DATE NOT NULL
);

ALTER TABLE RECHERCHE.REPART_UNIT_RECH_DOM_SC ADD (PRIMARY KEY (RURDS_ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.REPART_UNIT_RECH_DOM_SC ADD (
	CONSTRAINT FK_RURDS_DS 
	FOREIGN KEY (DOMAINE_SCIENT_ORDRE) 
	REFERENCES GRHUM.DOMAINE_SCIENTIFIQUE (DS_ORDRE) DEFERRABLE INITIALLY DEFERRED
);

ALTER TABLE RECHERCHE.REPART_UNIT_RECH_DOM_SC ADD (
	CONSTRAINT FK_RURDS_C_STR
	FOREIGN KEY (C_STRUCTURE) 
	REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE) DEFERRABLE INITIALLY DEFERRED
);

CREATE TABLE RECHERCHE.GRD_SECT_DISCIPLINAIRE 
(
	GSD_ID NUMBER NOT NULL,
	GSD_LIBELLE VARCHAR2(50) NOT NULL
);

ALTER TABLE RECHERCHE.GRD_SECT_DISCIPLINAIRE ADD (PRIMARY KEY (GSD_ID) USING INDEX TABLESPACE INDX_GRHUM);

CREATE TABLE RECHERCHE.REPART_GRD_SECT_DS 
(
	GSDS_ID NUMBER NOT NULL,
	GSD_ID NUMBER NOT NULL,
	DS_ID NUMBER NOT NULL
);

ALTER TABLE RECHERCHE.REPART_GRD_SECT_DS ADD (PRIMARY KEY (GSDS_ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.REPART_GRD_SECT_DS ADD (
	CONSTRAINT FK_GSDS_GSD_ID 
	FOREIGN KEY (GSD_ID) 
	REFERENCES RECHERCHE.GRD_SECT_DISCIPLINAIRE (GSD_ID) DEFERRABLE INITIALLY DEFERRED
);

CREATE TABLE RECHERCHE.RECONNAISSANCE_UNITE
(
	REC_UNI_ID NUMBER NOT NULL,
	C_STR_UNITE VARCHAR2(10) DEFAULT '0' NOT NULL,
	REC_LABEL VARCHAR2(10),
	REC_NUMERO NUMBER NOT NULL,
	REC_DATE_DEBUT DATE NOT NULL,
	REC_DATE_FIN DATE,
	PERS_ID_CREATION NUMBER NOT NULL,
	PERS_ID_MODIFICATION NUMBER NOT NULL,
	D_CREATION DATE NOT NULL,
	D_MODIFICATION DATE NOT NULL
);

ALTER TABLE RECHERCHE.RECONNAISSANCE_UNITE ADD (PRIMARY KEY (REC_UNI_ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.RECONNAISSANCE_UNITE ADD (
	CONSTRAINT FK_RU_C_STR_UNITE
	FOREIGN KEY (C_STR_UNITE) 
	REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE) DEFERRABLE INITIALLY DEFERRED
);

CREATE TABLE RECHERCHE.TYPE_DOTATIONS 
(
	ID NUMBER NOT NULL,
	CODE VARCHAR2(20) NOT NULL,
	LIBELLE VARCHAR2(200) NOT NULL
);

ALTER TABLE RECHERCHE.TYPE_DOTATIONS ADD (PRIMARY KEY (ID) USING INDEX TABLESPACE INDX_GRHUM);


create table RECHERCHE.DOTATION_ANNUELLES
(
	ORDRE NUMBER NOT NULL,
	C_STR VARCHAR2(10) NOT NULL,
	C_STR_PROVENANCE VARCHAR2(10),
	TYPE_DOTATION_ID NUMBER NOT NULL,
	MONTANT NUMBER NOT NULL,
	ANNEE NUMBER(4) NOT NULL,
	COMMENTAIRE VARCHAR2(255),
	PERS_ID_CREATION NUMBER NOT NULL,
	PERS_ID_MODIFICATION NUMBER NOT NULL,
	D_CREATION DATE NOT NULL,
	D_MODIFICATION DATE NOT NULL 
);



ALTER TABLE RECHERCHE.DOTATION_ANNUELLES ADD (PRIMARY KEY (ORDRE) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.DOTATION_ANNUELLES ADD (
	CONSTRAINT FK_DA_C_STR
	FOREIGN KEY (C_STR) 
	REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE) DEFERRABLE INITIALLY DEFERRED
);

ALTER TABLE RECHERCHE.DOTATION_ANNUELLES ADD (
	CONSTRAINT FK_DA_C_STR_PROV
	FOREIGN KEY (C_STR_PROVENANCE) 
	REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE) DEFERRABLE INITIALLY DEFERRED
);


ALTER TABLE RECHERCHE.DOTATION_ANNUELLES ADD (
	CONSTRAINT FK_DA_T_DOTATION 
	FOREIGN KEY (TYPE_DOTATION_ID) 
	REFERENCES RECHERCHE.TYPE_DOTATIONS (ID) DEFERRABLE INITIALLY DEFERRED
);


-- Evaluation MESR
CREATE TABLE RECHERCHE.EVALUATION_MESR
(
	EVAL_MESR_ID NUMBER NOT NULL,
	C_STRUCT_UNITE VARCHAR2(10) DEFAULT '0' NOT NULL,
	ANNEE NUMBER(4) NOT NULL,
	DATE_RECEPTION_DOSSIER_DRV DATE,
	DOSSIER_COMPLET NUMBER(1),
	DATE_PASSAGE_CS DATE,
	AVIS_CS VARCHAR2(20),
	DATE_PASSAGE_CA DATE,
	AVIS_CA VARCHAR2(20),
	DATE_ENVOI_AERES DATE,
	DATE_ENVOI_MESR DATE,
	NOTE_CAL_SCIENT_PROD VARCHAR2(5),
	NOTE_RAY_ATTR VARCHAR2(5),
	NOTE_START_GOUV VARCHAR2(5),
	NOTE_APPREC_SUJ VARCHAR2(5),
	DEBUT_VISITE_AERES DATE,
	FIN_VISITE_AERES DATE,
	COU_RAPPORT_AERES NUMBER,
	COU_REPONSE_AERES NUMBER,
	COU_AVIS_DEF_MSTP NUMBER,
	ALRM_MI_PARCOURS_DATE DATE,
	ALRM_MI_PARCOURS_DEST NUMBER,
	ALRM_MI_PARCOURS_TXT VARCHAR(250),
	LBL_DEMANDE VARCHAR2(10),
	LBL_OBTENU VARCHAR2(10),
	NOTE_AERES VARCHAR2(10),
	PERS_ID_CREATION NUMBER NOT NULL,
	PERS_ID_MODIFICATION NUMBER NOT NULL,
	D_CREATION DATE NOT NULL,
	D_MODIFICATION DATE NOT NULL 
);

ALTER TABLE RECHERCHE.EVALUATION_MESR ADD (PRIMARY KEY (EVAL_MESR_ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.EVALUATION_MESR ADD (
	CONSTRAINT FK_EVME_C_STR
	FOREIGN KEY (C_STRUCT_UNITE) 
	REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE) DEFERRABLE INITIALLY DEFERRED
);

ALTER TABLE RECHERCHE.EVALUATION_MESR ADD (
	CONSTRAINT FK_EVME_ALRM_MP_DEST
	FOREIGN KEY (ALRM_MI_PARCOURS_DEST) 
	REFERENCES GRHUM.INDIVIDU_ULR (NO_INDIVIDU) DEFERRABLE INITIALLY DEFERRED
);

ALTER TABLE RECHERCHE.EVALUATION_MESR ADD (
	CONSTRAINT FK_EVME_LBL_DEM
	FOREIGN KEY (LBL_DEMANDE) 
	REFERENCES GRHUM.LABELS (LAB_ABR) DEFERRABLE INITIALLY DEFERRED
);

ALTER TABLE RECHERCHE.EVALUATION_MESR ADD (
	CONSTRAINT FK_EVME_LBL_OBT
	FOREIGN KEY (LBL_OBTENU) 
	REFERENCES GRHUM.LABELS (LAB_ABR) DEFERRABLE INITIALLY DEFERRED
);


-- gestion des mots-clés

CREATE TABLE RECHERCHE.MOTS_CLES (
	MC_ID NUMBER(38) NOT NULL,
	MC_LIBELLE VARCHAR2(100) NOT NULL
);

ALTER TABLE RECHERCHE.MOTS_CLES ADD (PRIMARY KEY (MC_ID) USING INDEX TABLESPACE INDX_GRHUM);

CREATE TABLE RECHERCHE.REPART_MC_DS (
	MCDS_ID NUMBER(38) NOT NULL,
	MC_ID NUMBER NOT NULL,
	DS_ORDRE NUMBER NOT NULL
);

ALTER TABLE RECHERCHE.REPART_MC_DS ADD (PRIMARY KEY (MCDS_ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.REPART_MC_DS ADD (
	CONSTRAINT FK_MCDS_DS 
	FOREIGN KEY (DS_ORDRE) 
	REFERENCES GRHUM.DOMAINE_SCIENTIFIQUE (DS_ORDRE) DEFERRABLE INITIALLY DEFERRED
);

ALTER TABLE RECHERCHE.REPART_MC_DS ADD (
	CONSTRAINT FK_MCDS_MC 
	FOREIGN KEY (MC_ID) 
	REFERENCES RECHERCHE.MOTS_CLES (MC_ID) DEFERRABLE INITIALLY DEFERRED
);



CREATE TABLE RECHERCHE.REPART_MC_UR (
	MCUR_ID NUMBER(38) NOT NULL,
	MC_ID NUMBER NOT NULL,
	C_STRUCTURE VARCHAR2(10) NOT NULL
);

ALTER TABLE RECHERCHE.REPART_MC_UR ADD (PRIMARY KEY (MCUR_ID) USING INDEX TABLESPACE INDX_GRHUM);

ALTER TABLE RECHERCHE.REPART_MC_UR ADD (
	CONSTRAINT FK_MCUR_UR 
	FOREIGN KEY (C_STRUCTURE) 
	REFERENCES GRHUM.STRUCTURE_ULR (C_STRUCTURE) DEFERRABLE INITIALLY DEFERRED
);

ALTER TABLE RECHERCHE.REPART_MC_UR ADD (
	CONSTRAINT FK_MCUR_MC 
	FOREIGN KEY (MC_ID) 
	REFERENCES RECHERCHE.MOTS_CLES (MC_ID) DEFERRABLE INITIALLY DEFERRED
);



